/* ----------------------------------------------------------------------- */
/*                                 SOLVEQ.H                                */
/*                                                                         */
/*                   ESTRUTURAS E TIPOS DO SOLVEQ 3.0                      */
/*                                                                         */
/*     (Veja o SOLVEQ.DOC para descricoes de cada estrutura ou funcao)     */
/*                                                                         */
/*                  (C) 1993, Lenimar Nunes de Andrade                     */
/*               UFPB - CCEN - Departamento de Matematica                  */
/*                           Joao Pessoa, PB                               */
/*                      CCENDM03 @ BRUFPB.BITNET                           */
/* ----------------------------------------------------------------------- */

#define float         long double
#define COEF(F, I)    (F).coef[I]
#define RECOEF(F, I)  (F).coef[I].a
#define IMCOEF(F, I)  (F).coef[I].b

typedef struct {
  float a, b;
} complexo;

typedef struct {
  int grau;
  complexo *coef;
} polinomio;

typedef struct {
  int grau;
  float *coef;
} PolinomioReal;

typedef struct {
  complexo zini, *raiz;
  int *iteracao1, *iteracao2, encontradas, linha, lim, nit1, nit2,
      *num, *den, decimais, CorDeFundo, CorDoTexto;
  float p0, q0, erro1, erro2, delta;
  char *metodo;
} solucao;

complexo RealPComp(float re, float im);
complexo ConvComp(char *x);
float AbsComp(complexo x);
int Rac(float x, char *fracao);
void InicializaPolinomio(polinomio *f);
void LiberaPolinomio(polinomio *f);
void CopiaPolinomio(polinomio *destino, polinomio origem);
void LePolinomio(polinomio *f);
void PoliAleatorio(polinomio *f);
void MostraPolinomio(polinomio  f, int L, int d);
void ConvPoli(char *s, polinomio *f);
void ConvPoli2(char *s, polinomio *p);
int SalvaPolinomio(char *NomeDoArquivo, polinomio f, int decimais);
int CarregaPolinomio(char *NomeDoArquivo, polinomio *f);
void MultiplicaPolinomios(polinomio f, polinomio g, polinomio *p);
complexo Valor(polinomio p, complexo z);
int Laguerre(int *t, polinomio f, complexo *x, float erro, int Max);
int Muller(int *t, polinomio f, complexo *x, float erro, int Max, float delta);
int Bairstow(PolinomioReal f, float *p, float *q, int *iteracoes, float erro,
                                                                      int Max);
int CalculaRaizRacional(PolinomioReal f, int *num, int *den);
int ResolveEqMetLag(polinomio f, solucao *x);
int ResolveEqMetMul(polinomio f, solucao *x);
int ResolveEqMetBtw(polinomio f, solucao *x);
int ResolveEqMetRac(polinomio f, solucao *x);
void ResolveEquacaoBinomia(polinomio f, solucao *x);
float MaxRaiz(polinomio f);
void DividePol(polinomio p, complexo z, polinomio *q, complexo *r);
int FormataPolinomio(polinomio p, int L, int inicio, char var,
                                       char *linhabas, char *linhaexp, int d);
complexo SegGrau(polinomio f, int raiz);
void TestaRaizes(polinomio f, solucao raizes, complexo *v, complexo *zinv);
void ConvertePolinomioRealComplexo(PolinomioReal f, polinomio *g);
void ConvertePolinomioComplexoReal(polinomio f, PolinomioReal *g);
float ValorReal(PolinomioReal p, float a);
void SegundoGrauReal(float p, float q, float *re1, float *im1,
                                       float *re2, float *im2);
void DividePolSegGrau(PolinomioReal f, float p, float q, PolinomioReal *g);
void InicializaPolinomioReal(PolinomioReal *f);
void LiberaPolinomioReal(PolinomioReal *f);
void CopiaPolinomioReal(PolinomioReal *f, PolinomioReal g);
void DividePolReal(PolinomioReal p, float b, PolinomioReal *q, float *r);
void LePolinomioReal(PolinomioReal *p);

/*** FIM DE "SOLVEQ.H" ***/
